Index: XIOS/trunk/src/buffer.cpp
===================================================================
--- XIOS/trunk/src/buffer.cpp	(revision 341)
+++ XIOS/trunk/src/buffer.cpp	(revision 342)
@@ -1,10 +1,8 @@
 #include "xmlioserver_spl.hpp"
-#include "buffer_ym.hpp"
+#include "buffer.hpp"
 
 
 namespace xios
 {
-  namespace ym
-  {
     CBuffer::CBuffer(void* buffer_,size_t size_)
     {
@@ -46,5 +44,4 @@
     }
     
-  }
 }
     
Index: XIOS/trunk/src/buffer.hpp
===================================================================
--- XIOS/trunk/src/buffer.hpp	(revision 341)
+++ XIOS/trunk/src/buffer.hpp	(revision 342)
@@ -1,4 +1,4 @@
-#ifndef __BUFFER_YM_HPP__
-#define __BUFFER_YM_HPP__
+#ifndef __BUFFER_HPP__
+#define __BUFFER_HPP__
 
 
@@ -7,6 +7,4 @@
 namespace xios
 {
-  namespace ym
-  {
   
     class CBuffer
@@ -73,8 +71,7 @@
   
  
-  }
 }
 
-#include "buffer_ym_impl.hpp" 
+#include "buffer_impl.hpp" 
 
 
Index: XIOS/trunk/src/buffer_impl.hpp
===================================================================
--- XIOS/trunk/src/buffer_impl.hpp	(revision 341)
+++ XIOS/trunk/src/buffer_impl.hpp	(revision 342)
@@ -1,9 +1,7 @@
-#ifndef __BUFFER_YM_IMPL_HPP__
-#define __BUFFER_YM_IMPL_HPP__
+#ifndef __BUFFER_IMPL_HPP__
+#define __BUFFER_IMPL_HPP__
 
 namespace xios
 {
-  namespace ym
-  {
 
 // template spectialisation : CBuffer::put
@@ -172,5 +170,4 @@
     }    
 
-  }
 }
   
Index: XIOS/trunk/src/buffer_server.hpp
===================================================================
--- XIOS/trunk/src/buffer_server.hpp	(revision 341)
+++ XIOS/trunk/src/buffer_server.hpp	(revision 342)
@@ -3,5 +3,5 @@
 
 #include "xmlioserver_spl.hpp"
-#include "buffer_ym.hpp"
+#include "buffer.hpp"
 #include <mpi.h>
 
Index: XIOS/trunk/src/client.cpp
===================================================================
--- XIOS/trunk/src/client.cpp	(revision 341)
+++ XIOS/trunk/src/client.cpp	(revision 342)
@@ -1,5 +1,5 @@
 #include "xmlioserver_spl.hpp"
 #include "cxios.hpp"
-#include "client_ym.hpp"
+#include "client.hpp"
 #include <boost/functional/hash.hpp>
 #include "type.hpp"
@@ -12,6 +12,4 @@
 namespace xios
 {                      
-  namespace ym
-  {
 
     MPI_Comm CClient::intraComm ;
@@ -196,4 +194,3 @@
       info(20) << "Client side context is finalized"<<endl ;
     }
-  }
 }
Index: XIOS/trunk/src/client.hpp
===================================================================
--- XIOS/trunk/src/client.hpp	(revision 341)
+++ XIOS/trunk/src/client.hpp	(revision 342)
@@ -1,4 +1,4 @@
-#ifndef __CLIENT_YM__HPP__
-#define __CLIENT_YM__HPP__
+#ifndef __CLIENT_HPP__
+#define __CLIENT_HPP__
 
 #include "xmlioserver_spl.hpp"
@@ -7,6 +7,4 @@
 namespace xios
 {                      
-  namespace ym
-  {
     class CClient
     {
@@ -22,5 +20,4 @@
        static bool is_MPI_Initialized ;
     } ;
-  }
 }
 
Index: XIOS/trunk/src/cxios.cpp
===================================================================
--- XIOS/trunk/src/cxios.cpp	(revision 341)
+++ XIOS/trunk/src/cxios.cpp	(revision 342)
@@ -2,6 +2,6 @@
 #include "xmlioserver_spl.hpp"
 #include "cxios.hpp"
-#include "client_ym.hpp"
-#include "server_ym.hpp"
+#include "client.hpp"
+#include "server.hpp"
 #include "tree_manager.hpp"
 #include <boost/functional/hash.hpp>
@@ -44,5 +44,5 @@
     else isServer=true ;
     
-    ym::CClient::initialize(codeId,localComm,returnComm) ;
+    CClient::initialize(codeId,localComm,returnComm) ;
 
   }   
@@ -50,5 +50,5 @@
   void CXios::clientFinalize(void)
   {
-     ym::CClient::finalize() ;    
+     CClient::finalize() ;    
   }   
   
@@ -62,5 +62,5 @@
     isServer=false ;
 
-    ym::CServer::initialize() ;
+    CServer::initialize() ;
   } 
   
Index: XIOS/trunk/src/interface/c/icdata.cpp
===================================================================
--- XIOS/trunk/src/interface/c/icdata.cpp	(revision 341)
+++ XIOS/trunk/src/interface/c/icdata.cpp	(revision 342)
@@ -18,5 +18,5 @@
 #include "icutil.hpp"
 #include "cxios.hpp"
-#include "client_ym.hpp"
+#include "client.hpp"
 #include "field.hpp"
 #include "field_impl.hpp"
@@ -62,5 +62,5 @@
      if (!cstr2string(context_id, len_context_id, str)) return;
      comm=MPI_Comm_f2c(*f_comm) ;
-     ym::CClient::registerContext(str,comm) ;
+     CClient::registerContext(str,comm) ;
    }
  
Index: XIOS/trunk/src/server.cpp
===================================================================
--- XIOS/trunk/src/server.cpp	(revision 341)
+++ XIOS/trunk/src/server.cpp	(revision 342)
@@ -1,5 +1,5 @@
 #include "xmlioserver_spl.hpp"
 #include "cxios.hpp"
-#include "server_ym.hpp"
+#include "server.hpp"
 #include "type.hpp"
 #include "context.hpp"
@@ -13,7 +13,4 @@
 namespace xios
 {                      
-  namespace ym
-  {
-
     MPI_Comm CServer::intraComm ;
     list<MPI_Comm> CServer::interComm ;
@@ -372,6 +369,3 @@
      }
      
-
-
-  }
 }
Index: XIOS/trunk/src/server.hpp
===================================================================
--- XIOS/trunk/src/server.hpp	(revision 341)
+++ XIOS/trunk/src/server.hpp	(revision 342)
@@ -1,4 +1,4 @@
-#ifndef __SERVER_YM__HPP__
-#define __SERVER_YM__HPP__
+#ifndef __SERVER_HPP__
+#define __SERVER_HPP__
 
 #include "xmlioserver_spl.hpp"
@@ -8,6 +8,4 @@
 namespace xios
 {
-  namespace ym
-  {
     class CServer
     {
@@ -40,5 +38,4 @@
       static bool is_MPI_Initialized ;
     } ;
-  }
 }
 
Index: XIOS/trunk/src/test/test_xios.cpp
===================================================================
--- XIOS/trunk/src/test/test_xios.cpp	(revision 341)
+++ XIOS/trunk/src/test/test_xios.cpp	(revision 342)
@@ -1,13 +1,9 @@
 #include "xmlioserver.hpp"
 #include "attribute_template_impl.hpp"
-/*
-#include "group_template_impl.hpp"
-#include "file.hpp"
-*/
 #include "buffer_out.hpp"
 #include "buffer_in.hpp"
 #include "type.hpp"
 #include "cxios.hpp"
-#include "client_ym.hpp"
+#include "client.hpp"
 #include "event_client.hpp"
 #include "context.hpp"
@@ -19,5 +15,4 @@
 
 using namespace std ;
-using namespace ym ;
 
 int main (int argc, char ** argv, char ** UNUSED (env))
@@ -70,7 +65,7 @@
    {
      CXios::initClientSide("test1") ;
-     ym::CClient::registerContext("toto",ym::CClient::intraComm) ;
-//     ym::CClient::registerContext("tata",ym::CClient::intraComm) ;
-     ym::CClient::registerContext("tutu",ym::CClient::intraComm) ;
+     CClient::registerContext("toto",CClient::intraComm) ;
+//     CClient::registerContext("tata",CClient::intraComm) ;
+     CClient::registerContext("tutu",CClient::intraComm) ;
      CObjectFactory::SetCurrentContextId("tutu") ;
      CContext*  tutu=(CObjectFactory::GetObject<CContext>("tutu")).get(); 
@@ -105,9 +100,9 @@
    {
      CXios::initClientSide("test2") ;
-     ym::CClient::registerContext("tito",ym::CClient::intraComm) ;
+     CClient::registerContext("tito",CClient::intraComm) ;
      CObjectFactory::SetCurrentContextId("tito") ;
      CContext*  tito=(CObjectFactory::GetObject<CContext>("tito")).get();
       
-     ym::CClient::registerContext("tete",ym::CClient::intraComm) ;
+     CClient::registerContext("tete",CClient::intraComm) ;
      CObjectFactory::SetCurrentContextId("tete") ;
      CContext*  tete=(CObjectFactory::GetObject<CContext>("tete")).get(); 
@@ -120,5 +115,5 @@
    {
      CXios::initClientSide("test3") ;
-     ym::CClient::registerContext("turlututu",ym::CClient::intraComm) ;
+     CClient::registerContext("turlututu",CClient::intraComm) ;
      CObjectFactory::SetCurrentContextId("turlututu") ;
      CContext*  turlututu=(CObjectFactory::GetObject<CContext>("turlututu")).get(); 