Index: XIOS/trunk/arch/arch-PW6_VARGAS.fcm
===================================================================
--- XIOS/trunk/arch/arch-PW6_VARGAS.fcm	(revision 369)
+++ XIOS/trunk/arch/arch-PW6_VARGAS.fcm	(revision 370)
@@ -7,5 +7,5 @@
 %LINKER         mpCC_r 
 
-%BASE_CFLAGS    -qmkshrobj -DNETCDF_PAR_HEADER -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY 
+%BASE_CFLAGS    -qmkshrobj  -DNETCDF_PAR_HEADER -qrtti -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY 
 %PROD_CFLAGS    -O3 -DBOOST_DISABLE_ASSERTS
 %DEV_CFLAGS     -DXIOS_DEBUG -g 
Index: XIOS/trunk/arch/arch-X64_HORUS.env
===================================================================
--- XIOS/trunk/arch/arch-X64_HORUS.env	(revision 370)
+++ XIOS/trunk/arch/arch-X64_HORUS.env	(revision 370)
@@ -0,0 +1,6 @@
+export HDF5_INC_DIR=$HOME/hdf5/include
+export HDF5_LIB_DIR=$HOME/hdf5/lib
+
+export NETCDF_INC_DIR=$HOME/netcdf4/include
+export NETCDF_LIB_DIR=$HOME/netcdf4/lib
+
Index: XIOS/trunk/arch/arch-X64_HORUS.fcm
===================================================================
--- XIOS/trunk/arch/arch-X64_HORUS.fcm	(revision 370)
+++ XIOS/trunk/arch/arch-X64_HORUS.fcm	(revision 370)
@@ -0,0 +1,21 @@
+################################################################################
+###################        Projet xios - xmlioserver       #####################
+################################################################################
+
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90  
+
+%NO_WARN        -W -Wall -Wno-unused-parameter -Wno-long-long -Wno-deprecated
+%BASE_CFLAGS    -ansi -DNETCDF_PAR_HEADER -D_NONE_  -w
+%PROD_CFLAGS    -O3 -DBOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -DXIOS_DEBUG -g 
+%DEBUG_CFLAGS   -DXIOS_DEBUG -g 
+
+%BASE_FFLAGS    -D_NONE_ 
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -DXIOS_DEBUG -g 
+%DEBUG_FFLAGS   -DXIOS_DEBUG -g 
+
+%BASE_INC       -D _NONE_
+%BASE_LD        -lstdc++ -lmpi_cxx
Index: XIOS/trunk/arch/arch-X64_HORUS.path
===================================================================
--- XIOS/trunk/arch/arch-X64_HORUS.path	(revision 370)
+++ XIOS/trunk/arch/arch-X64_HORUS.path	(revision 370)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
+
+OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_TITANE.fcm
===================================================================
--- XIOS/trunk/arch/arch-X64_TITANE.fcm	(revision 369)
+++ XIOS/trunk/arch/arch-X64_TITANE.fcm	(revision 370)
@@ -7,8 +7,8 @@
 %LINKER         mpif90  -nofor-main
 
-%BASE_CFLAGS    -ansi -DNETCDF_PAR_HEADER -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279
+%BASE_CFLAGS    -ansi  -DNETCDF_PAR_HEADER -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279
 %PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
 %DEV_CFLAGS     -D XIOS_DEBUG -g -traceback
-%DEBUG_CFLAGS   -D XIOS_DEBUG -g -traceback -fno-inline
+%DEBUG_CFLAGS   -D XIOS_DEBUG -DBZ_DEBUG -g -traceback -fno-inline
 
 %BASE_FFLAGS    -DXIOS_LIBRARY -DXIOS_LIBRARY 
Index: XIOS/trunk/arch/arch-X64_TITANE_GCC.fcm
===================================================================
--- XIOS/trunk/arch/arch-X64_TITANE_GCC.fcm	(revision 369)
+++ XIOS/trunk/arch/arch-X64_TITANE_GCC.fcm	(revision 370)
@@ -8,5 +8,5 @@
 
 %NO_WARN        -W -Wall -Wno-unused-parameter -Wno-long-long -Wno-deprecated
-%BASE_CFLAGS    -ansi -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY  -w
+%BASE_CFLAGS    -ansi -DNETCDF_PAR_HEADER -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY  -w
 %PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
 %DEV_CFLAGS     -D XIOS_DEBUG -g 
Index: XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.fcm
===================================================================
--- XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.fcm	(revision 369)
+++ XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.fcm	(revision 370)
@@ -7,5 +7,5 @@
 %LINKER         vtf90  -vt:f90 mpif90 -vt:inst manual -nofor-main -DVTRACE
 
-%BASE_CFLAGS    -ansi -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279
+%BASE_CFLAGS    -ansi -DNETCDF_PAR_HEADER -DXIOS_LIBRARY -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279
 %PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
 %DEV_CFLAGS     -D XIOS_DEBUG -g -traceback