Index: XIOS/trunk/src/buffer_client.cpp
===================================================================
--- XIOS/trunk/src/buffer_client.cpp	(revision 381)
+++ XIOS/trunk/src/buffer_client.cpp	(revision 382)
@@ -5,5 +5,5 @@
 #include "buffer_client.hpp"
 #include "cxios.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "tracer.hpp"
 
Index: XIOS/trunk/src/buffer_client.hpp
===================================================================
--- XIOS/trunk/src/buffer_client.hpp	(revision 381)
+++ XIOS/trunk/src/buffer_client.hpp	(revision 382)
@@ -4,5 +4,5 @@
 #include "xmlioserver_spl.hpp"
 #include "buffer_out.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/buffer_server.hpp
===================================================================
--- XIOS/trunk/src/buffer_server.hpp	(revision 381)
+++ XIOS/trunk/src/buffer_server.hpp	(revision 382)
@@ -4,5 +4,5 @@
 #include "xmlioserver_spl.hpp"
 #include "buffer.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/client.cpp
===================================================================
--- XIOS/trunk/src/client.cpp	(revision 381)
+++ XIOS/trunk/src/client.cpp	(revision 382)
@@ -7,5 +7,5 @@
 #include "context_client.hpp"
 #include "oasis_cinterface.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "timer.hpp"
 
Index: XIOS/trunk/src/client.hpp
===================================================================
--- XIOS/trunk/src/client.hpp	(revision 381)
+++ XIOS/trunk/src/client.hpp	(revision 382)
@@ -3,5 +3,5 @@
 
 #include "xmlioserver_spl.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/context_client.cpp
===================================================================
--- XIOS/trunk/src/context_client.cpp	(revision 381)
+++ XIOS/trunk/src/context_client.cpp	(revision 382)
@@ -9,5 +9,5 @@
 #include "event_client.hpp"
 #include "context.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "timer.hpp"
 
Index: XIOS/trunk/src/context_client.hpp
===================================================================
--- XIOS/trunk/src/context_client.hpp	(revision 381)
+++ XIOS/trunk/src/context_client.hpp	(revision 382)
@@ -6,5 +6,5 @@
 #include "buffer_client.hpp"
 #include "event_client.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/context_server.cpp
===================================================================
--- XIOS/trunk/src/context_server.cpp	(revision 381)
+++ XIOS/trunk/src/context_server.cpp	(revision 382)
@@ -10,5 +10,5 @@
 #include "file.hpp"
 #include "grid.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "tracer.hpp"
 #include "timer.hpp"
Index: XIOS/trunk/src/context_server.hpp
===================================================================
--- XIOS/trunk/src/context_server.hpp	(revision 381)
+++ XIOS/trunk/src/context_server.hpp	(revision 382)
@@ -4,5 +4,5 @@
 #include "event_server.hpp"
 #include "buffer_server.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/cxios.cpp
===================================================================
--- XIOS/trunk/src/cxios.cpp	(revision 381)
+++ XIOS/trunk/src/cxios.cpp	(revision 382)
@@ -6,5 +6,5 @@
 #include "xml_parser.hpp"
 #include <boost/functional/hash.hpp>
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/cxios.hpp
===================================================================
--- XIOS/trunk/src/cxios.hpp	(revision 381)
+++ XIOS/trunk/src/cxios.hpp	(revision 382)
@@ -3,5 +3,5 @@
 
 #include "xmlioserver_spl.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/event_client.cpp
===================================================================
--- XIOS/trunk/src/event_client.cpp	(revision 381)
+++ XIOS/trunk/src/event_client.cpp	(revision 382)
@@ -4,5 +4,5 @@
 #include "message.hpp"
 #include "type.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/input/inetcdf4.hpp
===================================================================
--- XIOS/trunk/src/input/inetcdf4.hpp	(revision 381)
+++ XIOS/trunk/src/input/inetcdf4.hpp	(revision 382)
@@ -7,7 +7,6 @@
 #include "array_new.hpp"
 
-#include <mpi.h>
-#define MPI_INCLUDED
-#include <netcdf.h>
+#include "mpi.hpp"
+#include "netcdf.hpp"
 
 #ifndef UNLIMITED_DIM
Index: XIOS/trunk/src/interface/c/icdata.cpp
===================================================================
--- XIOS/trunk/src/interface/c/icdata.cpp	(revision 381)
+++ XIOS/trunk/src/interface/c/icdata.cpp	(revision 382)
@@ -21,5 +21,5 @@
 #include "field.hpp"
 #include "context.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "timer.hpp"
 #include "array_new.hpp"
Index: XIOS/trunk/src/interface/c/oasis_cinterface.cpp
===================================================================
--- XIOS/trunk/src/interface/c/oasis_cinterface.cpp	(revision 381)
+++ XIOS/trunk/src/interface/c/oasis_cinterface.cpp	(revision 382)
@@ -1,5 +1,5 @@
 #include "oasis_cinterface.hpp"
 #include <string>
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/interface/c/oasis_cinterface.hpp
===================================================================
--- XIOS/trunk/src/interface/c/oasis_cinterface.hpp	(revision 381)
+++ XIOS/trunk/src/interface/c/oasis_cinterface.hpp	(revision 382)
@@ -2,5 +2,5 @@
 #define __OASIS_CINTERFACE__
 #include <string>
-#include <mpi.h>
+#include "mpi.hpp"
 
 extern "C"
Index: XIOS/trunk/src/mpi.hpp
===================================================================
--- XIOS/trunk/src/mpi.hpp	(revision 382)
+++ XIOS/trunk/src/mpi.hpp	(revision 382)
@@ -0,0 +1,15 @@
+#ifndef __XIOS_MPI_HPP__
+#define __XIOS_MPI_HPP__
+
+/* skip C++ Binding for mpich , intel MPI */
+#define MPICH_SKIP_MPICXX
+
+/* skip C++ Binding for SGI MPI library */
+#define MPI_NO_CPPBIND
+
+/* skip C++ Binding for OpenMPI */
+#define OMPI_SKIP_MPICXX
+
+#include <mpi.h>
+
+#endif
Index: XIOS/trunk/src/node/context.hpp
===================================================================
--- XIOS/trunk/src/node/context.hpp	(revision 381)
+++ XIOS/trunk/src/node/context.hpp	(revision 382)
@@ -12,5 +12,5 @@
 #include "data_output.hpp"
 
-#include <mpi.h>
+#include "mpi.hpp"
 
 
Index: XIOS/trunk/src/node/file.cpp
===================================================================
--- XIOS/trunk/src/node/file.cpp	(revision 381)
+++ XIOS/trunk/src/node/file.cpp	(revision 382)
@@ -15,5 +15,5 @@
 #include "xmlioserver_spl.hpp"
 #include "context_client.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios {
Index: XIOS/trunk/src/node/file.hpp
===================================================================
--- XIOS/trunk/src/node/file.hpp	(revision 381)
+++ XIOS/trunk/src/node/file.hpp	(revision 382)
@@ -10,5 +10,5 @@
 #include "attribute_enum.hpp"
 #include "attribute_enum_impl.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 
Index: XIOS/trunk/src/output/netcdf.hpp
===================================================================
--- XIOS/trunk/src/output/netcdf.hpp	(revision 381)
+++ XIOS/trunk/src/output/netcdf.hpp	(revision 382)
@@ -1,8 +1,7 @@
 #ifndef __XIOS_NETCDF_HPP__
 #define __XIOS_NETCDF_HPP__
-#include <mpi.h>
+#include "mpi.hpp"
 #define MPI_INCLUDED
 #include <netcdf.h>
-#undef MPI_INCLUDED
 
 #include "netcdf_version.hpp"
Index: XIOS/trunk/src/output/onetcdf4.cpp
===================================================================
--- XIOS/trunk/src/output/onetcdf4.cpp	(revision 381)
+++ XIOS/trunk/src/output/onetcdf4.cpp	(revision 382)
@@ -1,5 +1,5 @@
 #include "onetcdf4.hpp"
 #include "group_template.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "netcdf.hpp"
 
Index: XIOS/trunk/src/output/onetcdf4.hpp
===================================================================
--- XIOS/trunk/src/output/onetcdf4.hpp	(revision 381)
+++ XIOS/trunk/src/output/onetcdf4.hpp	(revision 382)
@@ -7,5 +7,5 @@
 #include "data_output.hpp"
 #include "array_new.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "netcdf.hpp"
 
Index: XIOS/trunk/src/server.cpp
===================================================================
--- XIOS/trunk/src/server.cpp	(revision 381)
+++ XIOS/trunk/src/server.cpp	(revision 382)
@@ -8,5 +8,5 @@
 #include <boost/functional/hash.hpp>
 #include <boost/algorithm/string.hpp>
-#include <mpi.h>
+#include "mpi.hpp"
 #include "tracer.hpp"
 #include "timer.hpp"
Index: XIOS/trunk/src/server.hpp
===================================================================
--- XIOS/trunk/src/server.hpp	(revision 381)
+++ XIOS/trunk/src/server.hpp	(revision 382)
@@ -4,5 +4,5 @@
 #include "xmlioserver_spl.hpp"
 #include "context.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace xios
Index: XIOS/trunk/src/test/test_xios.cpp
===================================================================
--- XIOS/trunk/src/test/test_xios.cpp	(revision 381)
+++ XIOS/trunk/src/test/test_xios.cpp	(revision 382)
@@ -12,5 +12,5 @@
 #include "object_template.hpp"
 #include "array_new.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 
 
Index: XIOS/trunk/src/timer.cpp
===================================================================
--- XIOS/trunk/src/timer.cpp	(revision 381)
+++ XIOS/trunk/src/timer.cpp	(revision 382)
@@ -1,4 +1,4 @@
 #include "timer.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include <string>
 #include <map>