Index: XIOS/trunk/src/config/properties.conf
===================================================================
--- XIOS/trunk/src/config/properties.conf	(revision 419)
+++ XIOS/trunk/src/config/properties.conf	(revision 421)
@@ -1,4 +1,4 @@
 /// Author ///
-DECLARE_PROPERTY  (StdString, AUTHOR, "OZDOBA HervÃ©, MEURDESOIF Yann")
+DECLARE_PROPERTY  (StdString, AUTHOR, "OZDOBA Herve, MEURDESOIF Yann")
 
 /// Version number ///
Index: XIOS/trunk/src/node/axis.cpp
===================================================================
--- XIOS/trunk/src/node/axis.cpp	(revision 419)
+++ XIOS/trunk/src/node/axis.cpp	(revision 421)
@@ -76,5 +76,5 @@
       if (size != true_size)
          ERROR("CAxis::checkAttributes(void)",
-               << "Le tableau \'value\' a une taille diffÃ©rente de celle indiquÃ©e dans l'attribut \'size\'")
+               << "The array \'value\' has a different size that the one defined by the \'size\' attribut")
 
       this->isChecked = true;
Index: XIOS/trunk/src/node/context.cpp
===================================================================
--- XIOS/trunk/src/node/context.cpp	(revision 419)
+++ XIOS/trunk/src/node/context.cpp	(revision 421)
@@ -76,5 +76,5 @@
          ERROR(" CContext::solveCalendar(void)",
                << "[ context id = " << this->getId() << " ] "
-               << "Impossible de dÃ©finir un calendrier (un attribut est manquant).");
+               << "Impossible to define a calendar (an attribute is missing).");
 
 #define DECLARE_CALENDAR(MType  , mtype)                              \
@@ -95,5 +95,5 @@
       ERROR("CContext::solveCalendar(void)",
             << "[ calendar_type = " << calendar_type.getValue() << " ] "
-            << "Le calendrier n'est pas dÃ©finie dans le code !");
+            << "The calendar is not defined !");
    }
    
@@ -117,5 +117,5 @@
 
       if (node.getElementName().compare(CContext::GetName()))
-         DEBUG("Le noeud est mal nommÃ© mais sera traitÃ© comme un contexte !");
+         DEBUG("Le noeud is wrong defined but will be considered as a context !");
 
       if (!(node.goToChildElement()))
@@ -132,6 +132,6 @@
 
             if (attributes.end() != attributes.find("id"))
-            { DEBUG(<< "Le noeud de dÃ©finition possÃšde un identifiant,"
-                    << " ce dernier ne sera pas pris en compte lors du traitement !"); }
+            { DEBUG(<< "Definition node has an id,"
+                    << "it will not be taking account !"); }
 
 #define DECLARE_NODE(Name_, name_)    \
@@ -141,7 +141,7 @@
 #include "node_type.conf"
 
-            DEBUG(<< "L'Ã©lÃ©ment nommÃ© \'"     << name
-                  << "\' dans le contexte \'" << CContext::getCurrent()->getId()
-                  << "\' ne reprÃ©sente pas une dÃ©finition !");
+            DEBUG(<< "The element \'"     << name
+                  << "\' in the context \'" << CContext::getCurrent()->getId()
+                  << "\' is not a definition !");
 
          } while (node.goToNextElement());
Index: XIOS/trunk/src/node/domain.cpp
===================================================================
--- XIOS/trunk/src/node/domain.cpp	(revision 419)
+++ XIOS/trunk/src/node/domain.cpp	(revision 421)
@@ -155,6 +155,6 @@
          ERROR("CDomain::checkAttributes(void)",
                << "[ Id = " << this->getId() << " ] "
-               << "Le domaine global est mal dÃ©fini,"
-               << " vÃ©rifiez les valeurs de \'ni_glo\' et \'nj_glo\' !") 
+               << "The global domain is badly defined,"
+               << " check the \'ni_glo\' et \'nj_glo\' values !") 
       }
    }
@@ -177,12 +177,12 @@
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Le domaine est mal dÃ©fini,"
-               << " iend est diffÃ©rent de (ibegin + ni - 1) !") ;
+               << "The domain si wrong defined,"
+               << " iend is different of (ibegin + ni - 1) !") ;
       }
       else
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Le domaine est mal dÃ©fini,"
-               << " deux valeurs au moins parmis iend, ibegin, ni doivent Ãªtre dÃ©finies !") ;
+               << "The domain is wrong defined,"
+               << " 2 value from \'iend\', \'ibegin\', \'ni\'  must be defined !") ;
       }
 
@@ -192,6 +192,6 @@
          ERROR("CDomain::checkAttributes(void)",
                << "[ Id = " << this->getId() << " ] "
-               << "Domaine local mal dÃ©fini,"
-               << " vÃ©rifiez les valeurs ni, ni_glo, ibegin, iend") ;
+               << "Local domain is wrong defined,"
+               << " Check the value : ni, ni_glo, ibegin, iend") ;
 
    }
@@ -214,12 +214,12 @@
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Le domaine est mal dÃ©fini,"
-               << " iend est diffÃ©rent de (jbegin + nj - 1) !") ;
+               << "The domain is wrong defined,"
+               << " iend is different of (jbegin + nj - 1) !") ;
       }
       else
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Le domaine est mal dÃ©fini,"
-               << " deux valeurs au moins parmis jend, jbegin, nj doivent Ãªtre dÃ©finies !") ;
+               << "The domain is wrong defined,"
+               << " 2 values from  jend, jbegin, nj  must be defined !") ;
       }
 
@@ -227,6 +227,6 @@
           jbegin.getValue() < 1 || jend.getValue() > nj_glo.getValue())
          ERROR("CDomain::checkAttributes(void)",
-               << "Domaine local mal dÃ©fini,"
-               << " vÃ©rifiez les valeurs nj, nj_glo, jbegin, jend") ;
+               << "Domain is wrong defined,"
+               << " Check the values : nj, nj_glo, jbegin, jend") ;
    }
 
@@ -265,5 +265,5 @@
              (mask.extent(1) != nju))
             ERROR("CDomain::checkAttributes(void)",
-                  <<"Le masque n'a pas la mÃªme taille que le domaine local") ;
+                  <<"the mask has not the same size than the local domain") ;
                   
          for (int i = 0; i < ni.getValue(); i++)
@@ -303,10 +303,10 @@
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Dimension des donnÃ©es non comptatible (doit Ãªtre 1 ou 2) !") ;
+               << "Data dimension incompatible (must be 1 or 2) !") ;
       }
       else if (data_dim.isEmpty())
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Dimension des donnÃ©es non dÃ©finie !") ;
+               << "Data dimension undefined !") ;
       }
 
@@ -319,5 +319,5 @@
       {
          ERROR("CDomain::checkAttributes(void)",
-               << "Dimension des donnÃ©es nÃ©gative (data_ni).") ;
+               << "Data dimension is negative (data_ni).") ;
       }
       else if (data_ni.isEmpty())
@@ -333,5 +333,5 @@
          {
             ERROR("CDomain::checkAttributes(void)",
-                  << "Dimension des donnÃ©es nÃ©gative (data_nj).") ;
+                  << "Data dimension is negative (data_nj).") ;
          }
          else if (data_nj.isEmpty())
@@ -352,5 +352,5 @@
          {
             ERROR("CDomain::checkAttributes(void)",
-                  <<"Dimension data_i_index incompatible avec data_n_index.") ;
+                  <<"Dimension data_i_index incompatible with data_n_index.") ;
          }
          else if (data_n_index.isEmpty())
@@ -363,10 +363,10 @@
             {
                ERROR("CDomain::checkAttributes(void)",
-                     <<"Dimension data_j_index incompatible avec data_i_index.") ;
+                     <<"Dimension data_j_index incompatible with data_i_index.") ;
             }
             else if (data_j_index.isEmpty())
             {
                ERROR("CDomain::checkAttributes(void)",
-                     <<"La donnÃ©e data_j_index doit Ãªtre renseignÃ©e !") ;
+                     <<"data_j_index must be defined !") ;
             }
          }
@@ -376,5 +376,5 @@
          if (!data_n_index.isEmpty() ||
             ((data_dim.getValue() == 2) && (!data_j_index.isEmpty())))
-            ERROR("CDomain::checkAttributes(void)", << "data_i_index non dÃ©fini") ;
+            ERROR("CDomain::checkAttributes(void)", << "data_i_index undefined") ;
       }
 
@@ -552,6 +552,6 @@
                 zoom_iend > ni_glo.getValue() || zoom_jend > nj_glo.getValue())
                ERROR("CDomain::checkZoom(void)",
-                     << "Zoom mal dÃ©fini,"
-                     << " vÃ©rifiez les valeurs zoom_ni, zoom_nj, zoom_ibegin, zoom_ibegin") ;
+                     << "Zoom is wrong defined,"
+                     << " Check the values : zoom_ni, zoom_nj, zoom_ibegin, zoom_ibegin") ;
          }
       }
Index: XIOS/trunk/src/node/field.cpp
===================================================================
--- XIOS/trunk/src/node/field.cpp	(revision 419)
+++ XIOS/trunk/src/node/field.cpp	(revision 421)
@@ -367,5 +367,5 @@
          ERROR("CField::solveOperation(void)",
                << "[ id = " << id << "]"
-               << "Impossible de dÃ©finir une opÃ©ration pour le champ !");
+               << "Impossible to define an operation for this field !");
       }
       
@@ -425,5 +425,5 @@
          ERROR("CField::solveOperation(void)",
                << "[ operation = " << operation.getValue() << "]"
-               << "L'opÃ©ration n'est pas dÃ©finie dans le code !");
+               << "The operation is not defined !");
       }
    }
@@ -456,6 +456,6 @@
          else
             ERROR("CField::solveGridReference(void)",
-                  << "RÃ©fÃ©rence au domaine nommÃ© \'"
-                  << domain_ref.getValue() << "\' incorrecte") ;
+                  << "Reference to the domain \'"
+                  << domain_ref.getValue() << "\' is wrong") ;
       }
 
@@ -466,6 +466,6 @@
          else
             ERROR("CField::solveGridReference(void)",
-                  << "RÃ©fÃ©rence Ã  l'axe nommÃ© \'"
-                  << axis_ref.getValue() <<"\' incorrecte") ;
+                  << "Reference to the axis \'"
+                  << axis_ref.getValue() <<"\' is wrong") ;
       }
 
@@ -476,6 +476,6 @@
          else
             ERROR("CField::solveGridReference(void)",
-                  << "RÃ©fÃ©rence Ã  la grille nommÃ©e \'"
-                  << grid_ref.getValue() << "\' incorrecte");
+                  << "Reference to the grid \'"
+                  << grid_ref.getValue() << "\' is wrong");
       }
       
@@ -483,5 +483,5 @@
       {
             ERROR("CField::solveGridReference(void)",
-                  << "Le domaine horizontal pour le champ X n'est pas dÃ©fini");
+                  << "The horizontal domain for this field is not defined");
 
      }
@@ -500,10 +500,10 @@
      if (goodDomain.isEmpty()) 
      {
-       ERROR("CField::solveGridReference(void)", << "Le domaine horizontal pour le champ X n'est pas dÃ©fini");
+       ERROR("CField::solveGridReference(void)", << "The horizontal domain for this field is not defined");
      }
      else 
      {
        if (CDomain::has(goodDomain)) domain = CDomain::get(goodDomain) ;
-       else ERROR("CField::solveGridReference(void)",<< "RÃ©fÃ©rence au domaine nommÃ© \'"<<goodDomain.get() << "\' incorrecte") ;
+       else ERROR("CField::solveGridReference(void)",<< "Reference to the domain \'"<<goodDomain.get() << "\' is wrong") ;
      }
  
@@ -511,6 +511,6 @@
      {
        if (CAxis::has(goodAxis))  axis = CAxis::get(goodAxis) ;
-       else  ERROR("CField::solveGridReference(void)", << "RÃ©fÃ©rence Ã  l'axe nommÃ© \'"
-                  << goodAxis.get() <<"\' incorrecte") ;
+       else  ERROR("CField::solveGridReference(void)", << "Reference to the axis \'"
+                  << goodAxis.get() <<"\' is wrong") ;
      } 
     
Index: XIOS/trunk/src/node/grid.cpp
===================================================================
--- XIOS/trunk/src/node/grid.cpp	(revision 419)
+++ XIOS/trunk/src/node/grid.cpp	(revision 421)
@@ -206,5 +206,5 @@
              (mask.extent(2) != nlu))
              ERROR("CGrid::checkAttributes(void)",
-                  <<"Le masque n'a pas la mÃªme taille que la grille locale") ;
+                  <<"The mask has not the same size than the local grid") ;
       }
       else 
@@ -234,8 +234,8 @@
          }
          else ERROR("CGrid::solveDomainRef(void)",
-                     << "RÃ©fÃ©rence au domaine incorrecte") ;
+                     << "Wrong domain reference") ;
       }
       else ERROR("CGrid::solveDomainRef(void)",
-                  << "Domaine non dÃ©fini") ;
+                  << "Domain reference is not defined") ;
    }
 
@@ -253,5 +253,5 @@
          }
          else ERROR("CGrid::solveAxisRef(void)",
-                    << "RÃ©fÃ©rence a l'axe incorrecte") ;
+                    << "Wrong axis reference") ;
       }
       else withAxis = false ;
@@ -530,7 +530,7 @@
       if ((this->storeIndex.size()-1 ) != storedClient.size())
          ERROR("void CGrid::inputFieldServer(const std::deque< CArray<double, 1>* > storedClient, CArray<double, 1>&  storedServer) const",
-                << "[ Nombre de tableau attendu = " << (this->storeIndex.size()-1) << ", "
-                << "[ Nombre de tableau reÃ§u = "    << storedClient.size() << "] "
-                << "Les donnÃ©es d'un client sont manquantes !") ;
+                << "[ Expected received field = " << (this->storeIndex.size()-1) << ", "
+                << "[ received fiedl = "    << storedClient.size() << "] "
+                << "Data from clients are missing!") ;
       storedServer.resize(storeIndex[0]->numElements());
          
Index: XIOS/trunk/src/node/grid.hpp
===================================================================
--- XIOS/trunk/src/node/grid.hpp	(revision 419)
+++ XIOS/trunk/src/node/grid.hpp	(revision 421)
@@ -162,7 +162,7 @@
       if (this->getDataSize() != field.numElements())
          ERROR("void CGrid::inputField(const  CArray<double,n>& field, CArray<double,1>& stored) const",
-                << "[ Taille des donnÃ©es attendue = " << this->getDataSize()       << ", "
-                << "Taille des donnÃ©es reÃ§ue = "      << field.numElements() << " ] "
-                << "Le tableau de donnÃ©es n'a pas la bonne taille !") ;
+                << "[ Awaiting size of the data = " << this->getDataSize()       << ", "
+                << "Received data size = "      << field.numElements() << " ] "
+                << "The array of data has not the good size !")
       this->storeField_arr(field.dataFirst(), stored) ;
    }