Index: XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90	(revision 415)
+++ XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90	(revision 432)
@@ -13,5 +13,5 @@
   SUBROUTINE xios(set_file_attr)  &
     ( file_id, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-    , split_freq, sync_freq, type )
+    , split_freq, split_freq_format, sync_freq, type )
     
     IMPLICIT NONE
@@ -28,4 +28,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
@@ -34,5 +35,5 @@
       CALL xios(set_file_attr_hdl_)   &
       ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-      , split_freq, sync_freq, type )
+      , split_freq, split_freq_format, sync_freq, type )
     
   END SUBROUTINE xios(set_file_attr)
@@ -40,5 +41,5 @@
   SUBROUTINE xios(set_file_attr_hdl)  &
     ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-    , split_freq, sync_freq, type )
+    , split_freq, split_freq_format, sync_freq, type )
     
     IMPLICIT NONE
@@ -54,4 +55,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
@@ -59,5 +61,5 @@
       CALL xios(set_file_attr_hdl_)  &
       ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-      , split_freq, sync_freq, type )
+      , split_freq, split_freq_format, sync_freq, type )
     
   END SUBROUTINE xios(set_file_attr_hdl)
@@ -65,5 +67,5 @@
   SUBROUTINE xios(set_file_attr_hdl_)   &
     ( file_hdl, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_, output_level_  &
-    , par_access_, split_freq_, sync_freq_, type_ )
+    , par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
     
     IMPLICIT NONE
@@ -79,4 +81,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: par_access_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
@@ -119,4 +122,8 @@
       ENDIF
       
+      IF (PRESENT(split_freq_format_)) THEN
+        CALL cxios_set_file_split_freq_format(file_hdl%daddr, split_freq_format_, len(split_freq_format_))
+      ENDIF
+      
       IF (PRESENT(sync_freq_)) THEN
         CALL cxios_set_file_sync_freq(file_hdl%daddr, sync_freq_, len(sync_freq_))
@@ -133,5 +140,5 @@
   SUBROUTINE xios(get_file_attr)  &
     ( file_id, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-    , split_freq, sync_freq, type )
+    , split_freq, split_freq_format, sync_freq, type )
     
     IMPLICIT NONE
@@ -148,4 +155,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
@@ -154,5 +162,5 @@
       CALL xios(get_file_attr_hdl_)   &
       ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-      , split_freq, sync_freq, type )
+      , split_freq, split_freq_format, sync_freq, type )
     
   END SUBROUTINE xios(get_file_attr)
@@ -160,5 +168,5 @@
   SUBROUTINE xios(get_file_attr_hdl)  &
     ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-    , split_freq, sync_freq, type )
+    , split_freq, split_freq_format, sync_freq, type )
     
     IMPLICIT NONE
@@ -174,4 +182,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
@@ -179,5 +188,5 @@
       CALL xios(get_file_attr_hdl_)  &
       ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
-      , split_freq, sync_freq, type )
+      , split_freq, split_freq_format, sync_freq, type )
     
   END SUBROUTINE xios(get_file_attr_hdl)
@@ -185,5 +194,5 @@
   SUBROUTINE xios(get_file_attr_hdl_)   &
     ( file_hdl, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_, output_level_  &
-    , par_access_, split_freq_, sync_freq_, type_ )
+    , par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
     
     IMPLICIT NONE
@@ -199,4 +208,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: par_access_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
@@ -239,4 +249,8 @@
       ENDIF
       
+      IF (PRESENT(split_freq_format_)) THEN
+        CALL cxios_get_file_split_freq_format(file_hdl%daddr, split_freq_format_, len(split_freq_format_))
+      ENDIF
+      
       IF (PRESENT(sync_freq_)) THEN
         CALL cxios_get_file_sync_freq(file_hdl%daddr, sync_freq_, len(sync_freq_))
@@ -251,3 +265,174 @@
   END SUBROUTINE xios(get_file_attr_hdl_)
   
+  SUBROUTINE xios(is_defined_file_attr)  &
+    ( file_id, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
+    , split_freq, split_freq_format, sync_freq, type )
+    
+    IMPLICIT NONE
+      TYPE(txios(file))  :: file_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::file_id
+      LOGICAL, OPTIONAL, INTENT(OUT) :: description
+      LOGICAL(KIND=C_BOOL) :: description_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: enabled
+      LOGICAL(KIND=C_BOOL) :: enabled_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: min_digits
+      LOGICAL(KIND=C_BOOL) :: min_digits_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name
+      LOGICAL(KIND=C_BOOL) :: name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name_suffix
+      LOGICAL(KIND=C_BOOL) :: name_suffix_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_freq
+      LOGICAL(KIND=C_BOOL) :: output_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_level
+      LOGICAL(KIND=C_BOOL) :: output_level_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: par_access
+      LOGICAL(KIND=C_BOOL) :: par_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq
+      LOGICAL(KIND=C_BOOL) :: split_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format
+      LOGICAL(KIND=C_BOOL) :: split_freq_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
+      LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+      
+      CALL xios(get_file_handle)(file_id,file_hdl)
+      CALL xios(is_defined_file_attr_hdl_)   &
+      ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
+      , split_freq, split_freq_format, sync_freq, type )
+    
+  END SUBROUTINE xios(is_defined_file_attr)
+  
+  SUBROUTINE xios(is_defined_file_attr_hdl)  &
+    ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
+    , split_freq, split_freq_format, sync_freq, type )
+    
+    IMPLICIT NONE
+      TYPE(txios(file)) , INTENT(IN) :: file_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: description
+      LOGICAL(KIND=C_BOOL) :: description_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: enabled
+      LOGICAL(KIND=C_BOOL) :: enabled_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: min_digits
+      LOGICAL(KIND=C_BOOL) :: min_digits_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name
+      LOGICAL(KIND=C_BOOL) :: name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name_suffix
+      LOGICAL(KIND=C_BOOL) :: name_suffix_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_freq
+      LOGICAL(KIND=C_BOOL) :: output_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_level
+      LOGICAL(KIND=C_BOOL) :: output_level_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: par_access
+      LOGICAL(KIND=C_BOOL) :: par_access_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq
+      LOGICAL(KIND=C_BOOL) :: split_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format
+      LOGICAL(KIND=C_BOOL) :: split_freq_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
+      LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+      
+      CALL xios(is_defined_file_attr_hdl_)  &
+      ( file_hdl, description, enabled, min_digits, name, name_suffix, output_freq, output_level, par_access  &
+      , split_freq, split_freq_format, sync_freq, type )
+    
+  END SUBROUTINE xios(is_defined_file_attr_hdl)
+  
+  SUBROUTINE xios(is_defined_file_attr_hdl_)   &
+    ( file_hdl, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_, output_level_  &
+    , par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
+    
+    IMPLICIT NONE
+      TYPE(txios(file)) , INTENT(IN) :: file_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: description_
+      LOGICAL(KIND=C_BOOL) :: description__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: enabled_
+      LOGICAL(KIND=C_BOOL) :: enabled__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: min_digits_
+      LOGICAL(KIND=C_BOOL) :: min_digits__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name_
+      LOGICAL(KIND=C_BOOL) :: name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name_suffix_
+      LOGICAL(KIND=C_BOOL) :: name_suffix__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_freq_
+      LOGICAL(KIND=C_BOOL) :: output_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: output_level_
+      LOGICAL(KIND=C_BOOL) :: output_level__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: par_access_
+      LOGICAL(KIND=C_BOOL) :: par_access__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_
+      LOGICAL(KIND=C_BOOL) :: split_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: split_freq_format_
+      LOGICAL(KIND=C_BOOL) :: split_freq_format__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
+      LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type_
+      LOGICAL(KIND=C_BOOL) :: type__tmp
+      
+      IF (PRESENT(description_)) THEN
+        description__tmp=cxios_is_defined_file_description(file_hdl%daddr)
+        description_=description__tmp
+      ENDIF
+      
+      IF (PRESENT(enabled_)) THEN
+        enabled__tmp=cxios_is_defined_file_enabled(file_hdl%daddr)
+        enabled_=enabled__tmp
+      ENDIF
+      
+      IF (PRESENT(min_digits_)) THEN
+        min_digits__tmp=cxios_is_defined_file_min_digits(file_hdl%daddr)
+        min_digits_=min_digits__tmp
+      ENDIF
+      
+      IF (PRESENT(name_)) THEN
+        name__tmp=cxios_is_defined_file_name(file_hdl%daddr)
+        name_=name__tmp
+      ENDIF
+      
+      IF (PRESENT(name_suffix_)) THEN
+        name_suffix__tmp=cxios_is_defined_file_name_suffix(file_hdl%daddr)
+        name_suffix_=name_suffix__tmp
+      ENDIF
+      
+      IF (PRESENT(output_freq_)) THEN
+        output_freq__tmp=cxios_is_defined_file_output_freq(file_hdl%daddr)
+        output_freq_=output_freq__tmp
+      ENDIF
+      
+      IF (PRESENT(output_level_)) THEN
+        output_level__tmp=cxios_is_defined_file_output_level(file_hdl%daddr)
+        output_level_=output_level__tmp
+      ENDIF
+      
+      IF (PRESENT(par_access_)) THEN
+        par_access__tmp=cxios_is_defined_file_par_access(file_hdl%daddr)
+        par_access_=par_access__tmp
+      ENDIF
+      
+      IF (PRESENT(split_freq_)) THEN
+        split_freq__tmp=cxios_is_defined_file_split_freq(file_hdl%daddr)
+        split_freq_=split_freq__tmp
+      ENDIF
+      
+      IF (PRESENT(split_freq_format_)) THEN
+        split_freq_format__tmp=cxios_is_defined_file_split_freq_format(file_hdl%daddr)
+        split_freq_format_=split_freq_format__tmp
+      ENDIF
+      
+      IF (PRESENT(sync_freq_)) THEN
+        sync_freq__tmp=cxios_is_defined_file_sync_freq(file_hdl%daddr)
+        sync_freq_=sync_freq__tmp
+      ENDIF
+      
+      IF (PRESENT(type_)) THEN
+        type__tmp=cxios_is_defined_file_type(file_hdl%daddr)
+        type_=type__tmp
+      ENDIF
+      
+      
+    
+  END SUBROUTINE xios(is_defined_file_attr_hdl_)
+  
 END MODULE ifile_attr